#define cvsversion cvs_20040527
%define specrel 5

# Detect the distribution we're using. Should work for Red Hat, Fedora, Mandrake, and clones thereof
%define __distdep %(/bin/rpm -qf /etc/redhat-release | %{__sed} 's/-[^-]*$//' | %{_bindir}/head -1)
%define __distpkg %(echo %{__distdep} | %{__sed} 's/-[^-]*$//')
%define __distvers %(echo %{__distdep} | %{__sed} 's/.*-//' | %{_bindir}/tr -d '[:alpha:]')
%define __distinit %(%{__sed} -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' /etc/redhat-release | %{_bindir}/tr -d '[:space:]' | %{_bindir}/cut -c 1-4 | %{_bindir}/tr '[:upper:]' '[:lower:]')
%define is_mandrake %(if %{__grep} '^Mandrake *[Ll]inux' /etc/redhat-release >/dev/null 2>&1; then echo 1; else echo 0; fi)

# Decide on a release tag and figure out which patches we'll need
%if %{is_mandrake}
%define libpcapver %(/bin/rpm -q --queryformat '%%{VERSION}' libpcap0 | %{__grep} '^[0-9]' | /bin/sort -n | %{_bindir}/tail -1)
%define rpmrel %{?cvsversion:0.%{cvsversion}.}%{specrel}mdk%{__distvers}
%else
%define libpcapver %(/bin/rpm -q --queryformat '%%{VERSION}' libpcap | %{__grep} '^[0-9]' | /bin/sort -n | %{_bindir}/tail -1)
%define rpmrel %{?cvsversion:0.%{cvsversion}.}%{specrel}.%{__distinit}%{__distvers}
%endif
%define libpcapmajver %(expr `echo '%{libpcapver}' | %{__sed} -e 's/\\..*//'` + 0)
%define libpcapminver %(expr `echo '%{libpcapver}' | %{__sed} -e 's/[^.]*\\.\\([^.]*\\).*/\\1/'` + 0)
%define need_bpf_patch %(if [ "%{libpcapmajver}" -gt 0 -o "%{libpcapminver}" -gt 7 ]; then echo 0; else echo 1; fi)
%define use_pcap_patch %(if [ -f "%{_includedir}/pcap-int.h" ]; then echo 1; else echo 0; fi)
%define use_crc_patch %(if %{__grep} change_resolv_conf /etc/sysconfig/network-scripts/network-functions >/dev/null 2>&1; then echo 1; else echo 0; fi)
%define use_atm_patch %(if %{__grep} atm_backend_t "%{_includedir}/linux/atm.h" >/dev/null 2>&1; then echo 0; else echo 1; fi)
%{!?__id_u:%define __id_u /bin/id -u}

Summary: The PPP (Point-to-Point Protocol) daemon.
Name: ppp
Version: 2.4.3
Release: %{rpmrel}
License: distributable
Group: System Environment/Daemons
Source0: ftp://ftp.samba.org/pub/ppp/ppp-%{?cvsversion:%{cvsversion}}%{!?cvsversion:%{version}}.tar.gz
Source1: ppp-2.3.5-pamd.conf
Source2: ppp.logrotate
Patch0: ppp-2.4.3-make.patch
Patch1: ppp-2.3.6-sample.patch
Patch2: ppp-2.4.2-libutil.patch
Patch3: ppp-2.4.1-varargs.patch
Patch4: ppp-2.4.3-lib64.patch
Patch5: ppp-2.4.3-bpf.patch
Patch6: ppp-2.4.3-dontwriteetc.patch
Patch7: ppp-2.4.2-pie.patch
Patch8: ppp-2.4.3-fix.patch
Patch9: ppp-2.4.3-fix64.patch
# Patch10: ppp-2.4.2-signal.patch already included upstream
Patch11: ppp-2.4.2-change_resolv_conf.patch
Patch12: ppp-2.4.2-pcap.patch
Patch13: ppp-2.4.3-no_strip.patch
Patch14: ppp-2.4.2-argv.patch
# Patch15: ppp-2.4.2-pppoatm.patch already included upstream, but may need bodges to get old distros to work
Patch16: ppp-2.4.2-pppoatm-mtu.patch
Patch17: ppp-2.4.2-pppoatm-make.patch
Patch18: ppp-2.4.3-pkgcheck.patch
Patch19: ppp-2.4.3-winbind.base64.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: pam-devel
%if %{is_mandrake}
BuildRequires: libpcap0-devel > 0.6.2
%else
BuildRequires: libpcap >= 0.6.2
%endif
Requires: glibc >= 2.0.6, /etc/pam.d/system-auth, logrotate
%if %{use_pcap_patch}
Requires: libpcap >= 14:0.8.3-6
%endif

# Non-RedHat patches:
Patch100: mppe_lower_mtu.diff
Patch101: ppp-2.4.2-ifname.diff
Patch102: ppp-2.4.3-atm_backend.patch

%description
The ppp package contains the PPP (Point-to-Point Protocol) daemon and
documentation for PPP support. The PPP protocol provides a method for
transmitting datagrams over serial point-to-point links. PPP is
usually used to dial in to an ISP (Internet Service Provider) or other
organization over a modem and phone line.

%prep
%setup  -q -n ppp%{!?cvsversion:-%{version}}
%patch0 -p1 -b .make
%patch1 -p1 -b .sample
# patch 2 depends on the -lutil in patch 0
%patch2 -p1 -b .libutil
%patch3 -p1 -b .varargs
# patch 4 depends on the -lutil in patch 0
%patch4 -p1 -b .lib64
%if %{need_bpf_patch}
%patch5 -p1 -b .bpf
%endif
%patch6 -p1 -b .dontwriteetc
%patch7 -p1 -b .pie
%patch8 -p1 -b .fix
%patch9 -p1 -b .fix64
%if %{use_crc_patch}
%patch11 -p1 -b .change_resolv_conf
%endif
%if %{use_pcap_patch}
%patch12 -p1 -b .pcap
%endif
%patch13 -p1 -b .no_strip
%patch14 -p1 -b .argv
%patch16 -p1 -b .atm-mtu
%patch17 -p1 -b .atm-make
%patch18 -p1 -b .pkgcheck
%patch19 -p1 -b .winbind.base64

%patch100 -p1 -b .mtu
%patch101 -p0 -b .ifname
%if %{use_atm_patch}
%patch102 -p1 -b .atm_backend
%endif

find . -depth -type d -name CVS -exec rm -rf {} \;
find . -type f -name "*.sample" | xargs rm -f
find . -type f -name "*.change_resolv_conf" | xargs rm -f

# Red Hat 7.x has SIOCSIFNAME defined in <linux/sockios.h> but not in <bits/ioctls.h>,
# which is included by <sys/ioctl.h> from pppd/sys-linux.c
# This symbol is needed for the interface name-changing patch, so here's a kludge...
if ! %{__grep} SIOCSIFNAME %{_includedir}/bits/ioctls.h >/dev/null 2>&1; then
	[ -f %{_includedir}/linux/sockios.h ] &&
		%{__grep} SIOCSIFNAME %{_includedir}/linux/sockios.h >> pppd/patchlevel.h
fi

%build
#find . -name 'Makefile*' -print0 | xargs -0 perl -pi.no_strip -e "s: -s : :g"
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -fPIC -Wall"
%configure
%{__make} DESTDIR= LIBDIR=%{_libdir}

%install
[ "$RPM_BUILD_ROOT" != "/" -a -n "$RPM_BUILD_ROOT" ] && %{__rm} -rf $RPM_BUILD_ROOT
%{__make} install DESTDIR=$RPM_BUILD_ROOT/usr LIBDIR=$RPM_BUILD_ROOT%{_libdir}/pppd/%{version}
%{__make} install-etcppp DESTDIR=$RPM_BUILD_ROOT

## it shouldn't be SUID root be default
#chmod 755 $RPM_BUILD_ROOT/usr/sbin/pppd

chmod -R go+r scripts
chmod ugo-x scripts/autopppd scripts/secure-card
chmod 0755 $RPM_BUILD_ROOT/%{_libdir}/pppd/%{version}/*.so
mkdir -p $RPM_BUILD_ROOT/etc/pam.d
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT/etc/pam.d/ppp

# Provide pointers for people who expect stuff in old places
ln -s ../../var/log/ppp/connect-errors $RPM_BUILD_ROOT/etc/ppp/connect-errors
ln -s ../../var/run/ppp/resolv.conf $RPM_BUILD_ROOT/etc/ppp/resolv.conf

# Logrotate script
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT/etc/logrotate.d/ppp

%clean
[ "$RPM_BUILD_ROOT" != "/" -a -n "$RPM_BUILD_ROOT" ] && %{__rm} -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%{_sbindir}/chat
%{_sbindir}/pppd
%{_sbindir}/pppdump
%{_sbindir}/pppstats
%{_sbindir}/pppoe-discovery
%{_mandir}/man8/chat.8*
%{_mandir}/man8/pppd.8*
%{_mandir}/man8/pppdump.8*
%{_mandir}/man8/pppstats.8*
%{_mandir}/man8/pppd-radattr.8*
%{_mandir}/man8/pppd-radius.8*
%{_includedir}/pppd
%{_libdir}/pppd
%dir /etc/ppp
%dir /var/run/ppp
%attr(700, root, root) %dir /var/log/ppp
%config /etc/ppp/chap-secrets
%config /etc/ppp/options
%config /etc/ppp/pap-secrets
%config /etc/pam.d/ppp
%config /etc/logrotate.d/ppp
/etc/ppp/connect-errors
/etc/ppp/resolv.conf
%doc FAQ PLUGINS README README.cbcp README.linux README.MPPE README.MSCHAP80 README.MSCHAP81 README.pwfd README.pppoe scripts sample

%changelog
* Thu May 12 2005 Peter Mueller <pmueller@sidestep.com> 2.4.3-5
- add patch from joseph@southwell.org to fix base64 winbind problem: see
  http://ppp.samba.org/cgi-bin/ppp-bugs/incoming?id=1162;expression=winbind;user=guest
  http://marc.theaimsgroup.com/?l=poptop-server&m=111505895225564&w=2

* Fri Feb 25 2005 Paul Howarth <paul@city-fan.org> 2.4.3-4
- add kludge to enable package to build with the ifname patch on Red Hat 7.x

* Tue Feb 22 2005 Paul Howarth <paul@city-fan.org> 2.4.3-3
- more tweaking of Mandrake-detection
- explicitly require libpcap >= 0.6.2 in order to get the build to break
  properly when the dependency isn't there

* Thu Feb 10 2005 Paul Howarth <paul@city-fan.org> 2.4.3-2
- tweaked Mandrake-detection
- add distribution/version to RPM release tag
- fix bpf patch to enable packet filtering with libpcap < 0.8.3

* Mon Nov 22 2004 Paul Howarth <paul@city-fan.org> 2.4.3-1
- first attempt at full 2.4.3 release
- install-etcppp to make install
- various patches updated to suit 2.4.3 code
- don't override BINDIR and MANDIR in make install
- new program pppoe-discovery
- new manpages for pppd-radattr and pppd-radius
- 2.4.3 assumes libpcap >= 0.8.3, so libpcap patch now applied in reverse on
  systems with older libpcap
- pppoatm module now built unconditionally
- horrible hacks with make/LIBDIR to get plugins installed in the right place

* Tue Nov  9 2004 Paul Howarth <paul@city-fan.org> 2.4.3-0.cvs_20040527.6
- import updates from RedHat 2.4.2-6.4.FC3 RPM
- pppoatm patches only used if atm_backend_t mentioned in
  %{_includedir}/linux/atm.h on build system

* Tue Nov  2 2004 Thomas Woerner <twoerner@redhat.com> 2.4.2-6.4.FC3
- fixed out of bounds memory access, possible DOS

* Thu Oct  7 2004 David Woodhouse <dwmw2@redhat.com> 2.4.2-6.3
- Fix use of 'demand' without explicit MTU/MRU with pppoatm

* Tue Oct  5 2004 David Woodhouse <dwmw2@redhat.com> 2.4.2-6.2
- Link pppoatm plugin against libresolv.
- Revert to linux-atm headers without the workaround for #127098

* Tue Oct  5 2004 Paul Howarth <paul@city-fan.org> 2.4.3-0.cvs_20040527.5
- renumber non-RedHat-originated patches so as not to clash with new ones
- import updates from RedHat 2.4.2-5.1 RPM
- example scripts use change_resolv_conf only if that function is present in
  /etc/sysconfig/network-scripts/network-functions on build system
- use features of new pcap library (>= 0.8.3-6) only if present on build system

* Mon Oct  4 2004 David Woodhouse <dwmw2@redhat.com> 2.4.2-6.1
- Include atmsap.h for pppoatm plugin.

* Mon Oct  4 2004 David Woodhouse <dwmw2@redhat.com> 2.4.2-6
- Add pppoatm plugin (#131555)

* Thu Sep 16 2004 Thomas Woerner <twoerner@redhat.com> 2.4.2-5.1
- fixed subscript out of range (#132677)

* Wed Sep 15 2004 Thomas Woerner <twoerner@redhat.com> 2.4.2-5
- example scripts are using change_resolv_conf to modify /etc/resolv.conf
  (#132482)
- require new libpcap library (>= 0.8.3-6) with a fix for inbound/outbound
  filter processing
- not using internal libpcap structures anymore, fixes inbound/outbound
  filter processing (#128053) 

* Fri Aug  6 2004 Thomas Woerner <twoerner@redhat.com> 2.4.2-4
- fixed signal handling (#29171)

* Tue Jul 20 2004 Paul Howarth <paul@city-fan.org> 2.4.3-0.cvs_20040527.4
- remove previous Provides: kludge; this was a bad Conflicts: entry in
  the FC2 initscripts RPM, not a problem with ppp
- add Arvin Schnell's ifname patch
  (http://marc.theaimsgroup.com/?l=linux-ppp&m=109025160924399&w=2)

* Fri Jul  9 2004 Paul Howarth <paul@city-fan.org> 2.4.3-0.cvs_20040527.3
- imported updates from Fedora Core 2 errata release 2.4.2-3.FC2.1
- tweak ppp-2.4.2-fix.patch to remove fixes already included upstream
  and add new fix for 2.4.3
- add kludge to remove bogus Provides: for pppd and chat

* Mon Jun 21 2004 Thomas Woerner <twoerner@redhat.com> 2.4.2-3.1
- fixed compiler warnings
- fixed 64bit problem with ms-chap (#125501)
- enabled pie again

* Mon Jun 21 2004 Paul Howarth <paul@city-fan.org> 2.4.3-0.cvs_20040527.2
- add support for building under Mandrake Linux 10

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri May 28 2004 Paul Howarth <paul@city-fan.org> 2.4.3-0.cvs_20040527.1
- update to CVS version
- remove kill_my_pg patch, now fixed

* Wed May 26 2004 Paul Howarth <paul@city-fan.org> 2.4.2-4
- revert patch in kill_my_pg to fix termination problems
  (see http://marc.theaimsgroup.com/?l=linux-ppp&m=107498594022952&w=2)
- add patch to support mppe_lower_mtu/nomppe_lower_mtu options

* Tue May 25 2004 Paul Howarth <paul@city-fan.org> 2.4.2-3
- tweak to allow building with libpcap < 0.8 if required

* Wed May 24 2004 David Woodhouse <dwmw2@redhat.com> 2.4.2-2.3
- Enable IPv6 support. Disable PIE to avoid bogus Provides:

* Fri May 14 2004 Thomas Woerner <twoerner@redhat.com> 2.4.2-2.2
- compiled pppd and chat PIE

* Thu May 13 2004 Thomas Woerner <twoerner@redhat.com> 2.4.2-2.1
- added 'missingok' to ppp.logrotate (#122911)

* Fri May 07 2004 Nils Philippsen <nphilipp@redhat.com> 2.4.2-2
- don't write to /etc (#118837)

* Wed Mar 10 2004 Nalin Dahyabhai <nalin@redhat.com> 2.4.2-1
- update to 2.4.2

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Sep  5 2003 Nalin Dahyabhai <nalin@redhat.com> 2.4.1-15
- rebuild

* Fri Sep  5 2003 Nalin Dahyabhai <nalin@redhat.com> 2.4.1-14
- apply the patch from -11

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue Jun  3 2003 Nalin Dahyabhai <nalin@redhat.com> 2.4.1-12
- rebuild

* Tue Jun  3 2003 Nalin Dahyabhai <nalin@redhat.com> 2.4.1-11
- check for libcrypt in the right directory at compile-time

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Thu Dec 12 2002 Elliot Lee <sopwith@redhat.com> 2.4.1-9
- Fix build failure by rebuilding

* Tue Nov 19 2002 Nalin Dahyabhai <nalin@redhat.com> 2.4.1-8
- rebuild
- set x86_64 to use varargs the way s390 does

* Mon Jul 22 2002 Florian La Roche <Florian.LaRoche@redhat.de>
- add patch:
	* Thu Jun 06 2002 Phil Knirsch <pknirsch@redhat.com>
	- Fixed varargs problem for s390/s390x.

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Sun May 26 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Fri May 17 2002 Nalin Dahyabhai <nalin@redhat.com> 2.4.1-4
- rebuild in new environment

* Wed Feb 27 2002 Nalin Dahyabhai <nalin@redhat.com> 2.4.1-3
- revert cbcp patch, it's wrong (#55367)

* Thu Aug  9 2001 Nalin Dahyabhai <nalin@redhat.com> 2.4.1-2
- add buildprereq on pam-devel (#49559)
- add patch to respond to CBCP LCP requests (#15738)
- enable cbcp support at build-time
- change the Copyright: tag to a License: tag

* Wed May 23 2001 Nalin Dahyabhai <nalin@redhat.com> 2.4.1-1
- update to 2.4.1

* Fri Dec  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- rebuild in new environment

* Thu Nov  9 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.4.0

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Mon Jun  5 2000 Nalin Dahyabhai <nalin@redhat.com>
- move man pages to %{_mandir}

* Thu Jun  1 2000 Nalin Dahyabhai <nalin@redhat.com>
- change perms using defattr
- modify PAM setup to use system-auth

* Sun Mar 26 2000 Florian La Roche <Florian.La Roche@redhat.com>
- change to root:root perms

* Mon Mar 06 2000 Nalin Dahyabhai <nalin@redhat.com>
- reaper bugs verified as fixed
- check pam_open_session result code (bug #9966)

* Mon Feb 07 2000 Nalin Dahyabhai <nalin@redhat.com>
- take a shot at the wrong reaper bugs (#8153, #5290)

* Thu Feb 03 2000 Nalin Dahyabhai <nalin@redhat.com>
- free ride through the build system (release 2)

* Tue Jan 18 2000 Nalin Dahyabhai <nalin@redhat.com>
- Update to 2.3.11

* Sat Nov 06 1999 Michael K. Johnson <johnsonm@redhat.com>
- Better fix for both problems

* Fri Nov 05 1999 Michael K. Johnson <johnsonm@redhat.com>
- fix for double-dial problem
- fix for requiring a controlling terminal problem

* Sun Sep 19 1999 Preston Brown <pbrown@redhat.com>
- 2.3.10 bugfix release

* Fri Aug 13 1999 Michael K. Johnson <johnsonm@redhat.com>
- New version 2.3.9 required for kernel 2.3.13 and will be required
  for new initscripts.  auth patch removed; 2.3.9 does the same thing
  more readably than the previous patch.

* Thu Jun 24 1999 Cristian Gafton <gafton@redhat.com>
- add pppdump

* Fri Apr 09 1999 Cristian Gafton <gafton@redhat.com>
- force pppd use the glibc's logwtmp instead of implementing its own

* Wed Apr 01 1999 Preston Brown <pbrown@redhat.com>
- version 2.3.7 bugfix release

* Tue Mar 23 1999 Cristian Gafton <gafton@redhat.com>
- version 2.3.6

* Mon Mar 22 1999 Michael Johnson <johnsonm@redhat.com>
- auth patch

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 3)

* Thu Jan 07 1999 Cristian Gafton <gafton@redhat.com>
- build for glibc 2.1

* Fri Jun  5 1998 Jeff Johnson <jbj@redhat.com>
- updated to 2.3.5.

* Tue May 19 1998 Prospector System <bugs@redhat.com>
- translations modified for de

* Fri May  8 1998 Jakub Jelinek <jj@ultra.linux.cz>
- make it run with kernels 2.1.100 and above.

* Fri Apr 24 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed Mar 18 1998 Cristian Gafton <gafton@redhat.com>
- requires glibc 2.0.6 or later

* Wed Mar 18 1998 Michael K. Johnson <johnsonm@redhat.com>
- updated PAM patch to not turn off wtmp/utmp/syslog logging.

* Wed Jan  7 1998 Cristian Gafton <gafton@redhat.com>
- added the /etc/pam.d config file
- updated PAM patch to include session support

* Tue Jan  6 1998 Cristian Gafton <gafton@redhat.com>
- updated to ppp-2.3.3, build against glibc-2.0.6 - previous patches not
  required any more.
- added buildroot
- fixed the PAM support, which was really, completely broken and against any
  standards (session support is still not here... :-( )
- we build against running kernel and pray that it will work
- added a samples patch; updated glibc patch

* Thu Dec 18 1997 Erik Troan <ewt@redhat.com>
- added a patch to use our own route.h, rather then glibc's (which has 
  alignment problems on Alpha's) -- I only applied this patch on the Alpha,
  though it should be safe everywhere

* Fri Oct 10 1997 Erik Troan <ewt@redhat.com>
- turned off the execute bit for scripts in /usr/doc

* Fri Jul 18 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Tue Mar 25 1997 Erik Troan <ewt@redhat.com>
- Integrated new patch from David Mosberger
- Improved description

